import java.util.Scanner;

public class Sudoku {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int[][] sudoku;
        int n = sc.nextInt();
        boolean[] resp = new boolean[n];
        int atual;

        do {
            sudoku = new int[9][9];
            resp[n - 1] = true;
            for (int i = 0; i < sudoku.length; i++) {
                for (int j = 0; j < sudoku[i].length; j++) {
                    atual = sc.nextInt();
                    if (atual > 9 || atual < 0) {
                        resp[n - 1] = false;
                    }
                    else {
                      sudoku[i][j]=atual;
                    }
                }
            }
            if (resp[n - 1]) {
                //Verifica repetições nas linhas
               for (int i = 0; i < sudoku.length; i++) {
                    resp[n - 1] = valoresUnicos(sudoku[i]);
                    if (!resp[n - 1]) {
                        break;
                    }
                }
                if (resp[n - 1]) {
                    //Verifica repetições nas colunas
                    for (int i = 0; i < sudoku.length; i++) {
                        resp[n - 1] = valoresUnicos(colunaParaLinha(sudoku, i));
                        if (!resp[n - 1]) {
                            break;
                        }
                    }
                    if (resp[n - 1]) {
                        //Verifica repetições nos quadrados
                        for (int linha = 0; linha <= 6; linha = linha + 3) {
                            for (int coluna = 0; coluna <= 6; coluna = coluna + 3) {
                                resp[n - 1] = valoresUnicos(quadradoParaLinha(sudoku, linha, coluna));
                                if (!resp[n - 1]) {
                                    break;
                                }
                            }
                            if (!resp[n - 1]) {
                                break;
                            }
                        }
                    }
                }
            }
            n--;
        } while (n > 0);

        //Dá as respostas para os n sudokus
        int contador = 1;
        for (int i = resp.length - 1; i >= 0; i--) {
            System.out.println("Instancia " + contador++);
            if (resp[i]) {
                System.out.println("SIM\n");
            } else {
                System.out.println("NAO\n");
            }
        }
    }

    public static int[] quadradoParaLinha(int[][] matriz, int linhaPrimeiro, int colunaPrimeiro) {
        int[] novoArray = new int[9];
        int aux = 0;
        for (int i = linhaPrimeiro; i < linhaPrimeiro + 3; i++) {
            for (int j = colunaPrimeiro; j < colunaPrimeiro + 3; j++) {
                novoArray[aux] = matriz[i][j];
                aux++;
            }
        }
        return novoArray;
    }

    public static int[] colunaParaLinha(int[][] matriz, int coluna) {
        int[] novoArray = new int[9];
        for (int i = 0; i < matriz.length; i++) {
            novoArray[i] = matriz[i][coluna];
        }
        return novoArray;
    }

    //Quando tem números repetidos retorna false
    public static boolean valoresUnicos(int[] array) {
        int[] valores = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
        for (int i = 0; i < array.length; i++) {
            valores[array[i]]++;          
            if (valores[array[i]] != 1) {
                return false;
            }
        }
        return true;
    }
}
